"use strict";
var actionsRegistry_1 = require('./actionsRegistry');
function createAction(type, paramsCreator) {
    if (paramsCreator === void 0) { paramsCreator = function () { return ({}); }; }
    if (actionsRegistry_1.default.has(type)) {
        throw "Duplicate action " + type;
    }
    else {
        actionsRegistry_1.default.add(type);
    }
    var actionCreator = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i - 0] = arguments[_i];
        }
        var params = paramsCreator.apply(void 0, args);
        if ('type' in params) {
            console.warn('Property type is reserved by action');
        }
        return Object.assign(params, { type: type });
    };
    actionCreator.toString = function () { return type; };
    actionCreator.valueOf = function () { return (type + ","); };
    return actionCreator;
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = createAction;
